# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['DashboardArgs', 'Dashboard']

@pulumi.input_type
class DashboardArgs:
    def __init__(__self__, *,
                 layout_type: pulumi.Input[str],
                 title: pulumi.Input[str],
                 widgets: pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]],
                 dashboard_lists: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 is_read_only: Optional[pulumi.Input[bool]] = None,
                 notify_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 reflow_type: Optional[pulumi.Input[str]] = None,
                 restricted_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_variable_presets: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]] = None,
                 template_variables: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]] = None,
                 url: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a Dashboard resource.
        :param pulumi.Input[str] layout_type: The layout type of the dashboard. Valid values are `ordered`, `free`.
        :param pulumi.Input[str] title: The title of the dashboard.
        :param pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]] widgets: The list of widgets to display on the dashboard.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists: The list of dashboard lists this dashboard belongs to.
        :param pulumi.Input[str] description: The description of the dashboard.
        :param pulumi.Input[bool] is_read_only: Whether this dashboard is read-only.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notify_lists: The list of handles of users to notify when changes are made to this dashboard.
        :param pulumi.Input[str] reflow_type: The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] restricted_roles: Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        :param pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]] template_variable_presets: The list of selectable template variable presets for this dashboard.
        :param pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]] template_variables: The list of template variables for this dashboard.
        :param pulumi.Input[str] url: The URL of the dashboard.
        """
        pulumi.set(__self__, "layout_type", layout_type)
        pulumi.set(__self__, "title", title)
        pulumi.set(__self__, "widgets", widgets)
        if dashboard_lists is not None:
            pulumi.set(__self__, "dashboard_lists", dashboard_lists)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if is_read_only is not None:
            pulumi.set(__self__, "is_read_only", is_read_only)
        if notify_lists is not None:
            pulumi.set(__self__, "notify_lists", notify_lists)
        if reflow_type is not None:
            pulumi.set(__self__, "reflow_type", reflow_type)
        if restricted_roles is not None:
            pulumi.set(__self__, "restricted_roles", restricted_roles)
        if template_variable_presets is not None:
            pulumi.set(__self__, "template_variable_presets", template_variable_presets)
        if template_variables is not None:
            pulumi.set(__self__, "template_variables", template_variables)
        if url is not None:
            pulumi.set(__self__, "url", url)

    @property
    @pulumi.getter(name="layoutType")
    def layout_type(self) -> pulumi.Input[str]:
        """
        The layout type of the dashboard. Valid values are `ordered`, `free`.
        """
        return pulumi.get(self, "layout_type")

    @layout_type.setter
    def layout_type(self, value: pulumi.Input[str]):
        pulumi.set(self, "layout_type", value)

    @property
    @pulumi.getter
    def title(self) -> pulumi.Input[str]:
        """
        The title of the dashboard.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: pulumi.Input[str]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def widgets(self) -> pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]]:
        """
        The list of widgets to display on the dashboard.
        """
        return pulumi.get(self, "widgets")

    @widgets.setter
    def widgets(self, value: pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]]):
        pulumi.set(self, "widgets", value)

    @property
    @pulumi.getter(name="dashboardLists")
    def dashboard_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        The list of dashboard lists this dashboard belongs to.
        """
        return pulumi.get(self, "dashboard_lists")

    @dashboard_lists.setter
    def dashboard_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "dashboard_lists", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the dashboard.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="isReadOnly")
    def is_read_only(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this dashboard is read-only.
        """
        return pulumi.get(self, "is_read_only")

    @is_read_only.setter
    def is_read_only(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_read_only", value)

    @property
    @pulumi.getter(name="notifyLists")
    def notify_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of handles of users to notify when changes are made to this dashboard.
        """
        return pulumi.get(self, "notify_lists")

    @notify_lists.setter
    def notify_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "notify_lists", value)

    @property
    @pulumi.getter(name="reflowType")
    def reflow_type(self) -> Optional[pulumi.Input[str]]:
        """
        The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        """
        return pulumi.get(self, "reflow_type")

    @reflow_type.setter
    def reflow_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reflow_type", value)

    @property
    @pulumi.getter(name="restrictedRoles")
    def restricted_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        """
        return pulumi.get(self, "restricted_roles")

    @restricted_roles.setter
    def restricted_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "restricted_roles", value)

    @property
    @pulumi.getter(name="templateVariablePresets")
    def template_variable_presets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]]:
        """
        The list of selectable template variable presets for this dashboard.
        """
        return pulumi.get(self, "template_variable_presets")

    @template_variable_presets.setter
    def template_variable_presets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]]):
        pulumi.set(self, "template_variable_presets", value)

    @property
    @pulumi.getter(name="templateVariables")
    def template_variables(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]]:
        """
        The list of template variables for this dashboard.
        """
        return pulumi.get(self, "template_variables")

    @template_variables.setter
    def template_variables(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]]):
        pulumi.set(self, "template_variables", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL of the dashboard.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)


@pulumi.input_type
class _DashboardState:
    def __init__(__self__, *,
                 dashboard_lists: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 dashboard_lists_removeds: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 is_read_only: Optional[pulumi.Input[bool]] = None,
                 layout_type: Optional[pulumi.Input[str]] = None,
                 notify_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 reflow_type: Optional[pulumi.Input[str]] = None,
                 restricted_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_variable_presets: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]] = None,
                 template_variables: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 widgets: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]]] = None):
        """
        Input properties used for looking up and filtering Dashboard resources.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists: The list of dashboard lists this dashboard belongs to.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists_removeds: The list of dashboard lists this dashboard should be removed from. Internal only.
        :param pulumi.Input[str] description: The description of the dashboard.
        :param pulumi.Input[bool] is_read_only: Whether this dashboard is read-only.
        :param pulumi.Input[str] layout_type: The layout type of the dashboard. Valid values are `ordered`, `free`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notify_lists: The list of handles of users to notify when changes are made to this dashboard.
        :param pulumi.Input[str] reflow_type: The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] restricted_roles: Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        :param pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]] template_variable_presets: The list of selectable template variable presets for this dashboard.
        :param pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]] template_variables: The list of template variables for this dashboard.
        :param pulumi.Input[str] title: The title of the dashboard.
        :param pulumi.Input[str] url: The URL of the dashboard.
        :param pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]] widgets: The list of widgets to display on the dashboard.
        """
        if dashboard_lists is not None:
            pulumi.set(__self__, "dashboard_lists", dashboard_lists)
        if dashboard_lists_removeds is not None:
            pulumi.set(__self__, "dashboard_lists_removeds", dashboard_lists_removeds)
        if description is not None:
            pulumi.set(__self__, "description", description)
        if is_read_only is not None:
            pulumi.set(__self__, "is_read_only", is_read_only)
        if layout_type is not None:
            pulumi.set(__self__, "layout_type", layout_type)
        if notify_lists is not None:
            pulumi.set(__self__, "notify_lists", notify_lists)
        if reflow_type is not None:
            pulumi.set(__self__, "reflow_type", reflow_type)
        if restricted_roles is not None:
            pulumi.set(__self__, "restricted_roles", restricted_roles)
        if template_variable_presets is not None:
            pulumi.set(__self__, "template_variable_presets", template_variable_presets)
        if template_variables is not None:
            pulumi.set(__self__, "template_variables", template_variables)
        if title is not None:
            pulumi.set(__self__, "title", title)
        if url is not None:
            pulumi.set(__self__, "url", url)
        if widgets is not None:
            pulumi.set(__self__, "widgets", widgets)

    @property
    @pulumi.getter(name="dashboardLists")
    def dashboard_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        The list of dashboard lists this dashboard belongs to.
        """
        return pulumi.get(self, "dashboard_lists")

    @dashboard_lists.setter
    def dashboard_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "dashboard_lists", value)

    @property
    @pulumi.getter(name="dashboardListsRemoveds")
    def dashboard_lists_removeds(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        The list of dashboard lists this dashboard should be removed from. Internal only.
        """
        return pulumi.get(self, "dashboard_lists_removeds")

    @dashboard_lists_removeds.setter
    def dashboard_lists_removeds(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "dashboard_lists_removeds", value)

    @property
    @pulumi.getter
    def description(self) -> Optional[pulumi.Input[str]]:
        """
        The description of the dashboard.
        """
        return pulumi.get(self, "description")

    @description.setter
    def description(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "description", value)

    @property
    @pulumi.getter(name="isReadOnly")
    def is_read_only(self) -> Optional[pulumi.Input[bool]]:
        """
        Whether this dashboard is read-only.
        """
        return pulumi.get(self, "is_read_only")

    @is_read_only.setter
    def is_read_only(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "is_read_only", value)

    @property
    @pulumi.getter(name="layoutType")
    def layout_type(self) -> Optional[pulumi.Input[str]]:
        """
        The layout type of the dashboard. Valid values are `ordered`, `free`.
        """
        return pulumi.get(self, "layout_type")

    @layout_type.setter
    def layout_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "layout_type", value)

    @property
    @pulumi.getter(name="notifyLists")
    def notify_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        The list of handles of users to notify when changes are made to this dashboard.
        """
        return pulumi.get(self, "notify_lists")

    @notify_lists.setter
    def notify_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "notify_lists", value)

    @property
    @pulumi.getter(name="reflowType")
    def reflow_type(self) -> Optional[pulumi.Input[str]]:
        """
        The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        """
        return pulumi.get(self, "reflow_type")

    @reflow_type.setter
    def reflow_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "reflow_type", value)

    @property
    @pulumi.getter(name="restrictedRoles")
    def restricted_roles(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        """
        return pulumi.get(self, "restricted_roles")

    @restricted_roles.setter
    def restricted_roles(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "restricted_roles", value)

    @property
    @pulumi.getter(name="templateVariablePresets")
    def template_variable_presets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]]:
        """
        The list of selectable template variable presets for this dashboard.
        """
        return pulumi.get(self, "template_variable_presets")

    @template_variable_presets.setter
    def template_variable_presets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariablePresetArgs']]]]):
        pulumi.set(self, "template_variable_presets", value)

    @property
    @pulumi.getter(name="templateVariables")
    def template_variables(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]]:
        """
        The list of template variables for this dashboard.
        """
        return pulumi.get(self, "template_variables")

    @template_variables.setter
    def template_variables(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardTemplateVariableArgs']]]]):
        pulumi.set(self, "template_variables", value)

    @property
    @pulumi.getter
    def title(self) -> Optional[pulumi.Input[str]]:
        """
        The title of the dashboard.
        """
        return pulumi.get(self, "title")

    @title.setter
    def title(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "title", value)

    @property
    @pulumi.getter
    def url(self) -> Optional[pulumi.Input[str]]:
        """
        The URL of the dashboard.
        """
        return pulumi.get(self, "url")

    @url.setter
    def url(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "url", value)

    @property
    @pulumi.getter
    def widgets(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]]]:
        """
        The list of widgets to display on the dashboard.
        """
        return pulumi.get(self, "widgets")

    @widgets.setter
    def widgets(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['DashboardWidgetArgs']]]]):
        pulumi.set(self, "widgets", value)


class Dashboard(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dashboard_lists: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 is_read_only: Optional[pulumi.Input[bool]] = None,
                 layout_type: Optional[pulumi.Input[str]] = None,
                 notify_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 reflow_type: Optional[pulumi.Input[str]] = None,
                 restricted_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_variable_presets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariablePresetArgs']]]]] = None,
                 template_variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariableArgs']]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 widgets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardWidgetArgs']]]]] = None,
                 __props__=None):
        """
        Provides a Datadog dashboard resource. This can be used to create and manage Datadog dashboards.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_datadog as datadog

        # Example Ordered Layout
        ordered_dashboard = datadog.Dashboard("orderedDashboard",
            description="Created using the Datadog provider in Terraform",
            is_read_only=True,
            layout_type="ordered",
            template_variables=[
                datadog.DashboardTemplateVariableArgs(
                    default="aws",
                    name="var_1",
                    prefix="host",
                ),
                datadog.DashboardTemplateVariableArgs(
                    default="autoscaling",
                    name="var_2",
                    prefix="service_name",
                ),
            ],
            template_variable_presets=[datadog.DashboardTemplateVariablePresetArgs(
                name="preset_1",
                template_variables=[
                    {
                        "name": "var_1",
                        "value": "host.dc",
                    },
                    {
                        "name": "var_2",
                        "value": "my_service",
                    },
                ],
            )],
            title="Ordered Layout Dashboard",
            widgets=[
                datadog.DashboardWidgetArgs(
                    alert_graph_definition=datadog.DashboardWidgetAlertGraphDefinitionArgs(
                        alert_id="895605",
                        live_span="1h",
                        title="Widget Title",
                        viz_type="timeseries",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    alert_value_definition=datadog.DashboardWidgetAlertValueDefinitionArgs(
                        alert_id="895605",
                        precision=3,
                        text_align="center",
                        title="Widget Title",
                        unit="b",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    alert_value_definition=datadog.DashboardWidgetAlertValueDefinitionArgs(
                        alert_id="895605",
                        precision=3,
                        text_align="center",
                        title="Widget Title",
                        unit="b",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    change_definition=datadog.DashboardWidgetChangeDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "changeType": "absolute",
                            "compareTo": "week_before",
                            "increaseGood": True,
                            "orderBy": "name",
                            "orderDir": "desc",
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "showPresent": True,
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    distribution_definition=datadog.DashboardWidgetDistributionDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "style": {
                                "palette": "warm",
                            },
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    check_status_definition=datadog.DashboardWidgetCheckStatusDefinitionArgs(
                        check="aws.ecs.agent_connected",
                        group_by=[
                            "account",
                            "cluster",
                        ],
                        grouping="cluster",
                        live_span="1h",
                        tags=[
                            "account:demo",
                            "cluster:awseb-ruthebdog-env-8-dn3m6u3gvk",
                        ],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    heatmap_definition=datadog.DashboardWidgetHeatmapDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "style": {
                                "palette": "warm",
                            },
                        }],
                        title="Widget Title",
                        yaxis=datadog.DashboardWidgetHeatmapDefinitionYaxisArgs(
                            include_zero=True,
                            max="2",
                            min="1",
                            scale="sqrt",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    hostmap_definition=datadog.DashboardWidgetHostmapDefinitionArgs(
                        group=[
                            "host",
                            "region",
                        ],
                        no_group_hosts=True,
                        no_metric_hosts=True,
                        node_type="container",
                        request=datadog.DashboardWidgetHostmapDefinitionRequestArgs(
                            fill=[{
                                "q": "avg:system.load.1{*} by {host}",
                            }],
                            size=[{
                                "q": "avg:memcache.uptime{*} by {host}",
                            }],
                        ),
                        scope=[
                            "region:us-east-1",
                            "aws_account:727006795293",
                        ],
                        style=datadog.DashboardWidgetHostmapDefinitionStyleArgs(
                            fill_max="20",
                            fill_min="10",
                            palette="yellow_to_green",
                            palette_flip=True,
                        ),
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    note_definition=datadog.DashboardWidgetNoteDefinitionArgs(
                        background_color="pink",
                        content="note text",
                        font_size="14",
                        show_tick=True,
                        text_align="center",
                        tick_edge="left",
                        tick_pos="50%",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    query_value_definition=datadog.DashboardWidgetQueryValueDefinitionArgs(
                        autoscale=True,
                        custom_unit="xx",
                        live_span="1h",
                        precision=4,
                        request=[{
                            "aggregator": "sum",
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "q": "avg:system.load.1{env:staging} by {account}",
                        }],
                        text_align="right",
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    query_table_definition=datadog.DashboardWidgetQueryTableDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "aggregator": "sum",
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "limit": "10",
                            "q": "avg:system.load.1{env:staging} by {account}",
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    scatterplot_definition=datadog.DashboardWidgetScatterplotDefinitionArgs(
                        color_by_groups=[
                            "account",
                            "apm-role-group",
                        ],
                        live_span="1h",
                        request=datadog.DashboardWidgetScatterplotDefinitionRequestArgs(
                            x=[{
                                "aggregator": "max",
                                "q": "avg:system.cpu.user{*} by {service, account}",
                            }],
                            y=[{
                                "aggregator": "min",
                                "q": "avg:system.mem.used{*} by {service, account}",
                            }],
                        ),
                        title="Widget Title",
                        xaxis=datadog.DashboardWidgetScatterplotDefinitionXaxisArgs(
                            include_zero=True,
                            label="x",
                            max="2000",
                            min="1",
                            scale="pow",
                        ),
                        yaxis=datadog.DashboardWidgetScatterplotDefinitionYaxisArgs(
                            include_zero=False,
                            label="y",
                            max="2222",
                            min="5",
                            scale="log",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    servicemap_definition=datadog.DashboardWidgetServicemapDefinitionArgs(
                        filters=[
                            "env:prod",
                            "datacenter:us1.prod.dog",
                        ],
                        service="master-db",
                        title="env: prod, datacenter:us1.prod.dog, service: master-db",
                        title_align="left",
                        title_size="16",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        event=[
                            {
                                "q": "sources:test tags:1",
                            },
                            {
                                "q": "sources:test tags:2",
                            },
                        ],
                        legend_size="2",
                        live_span="1h",
                        marker=[
                            {
                                "displayType": "error dashed",
                                "label": " z=6 ",
                                "value": "y = 4",
                            },
                            {
                                "displayType": "ok solid",
                                "label": " x=8 ",
                                "value": "10 < y < 999",
                            },
                        ],
                        request=[
                            {
                                "displayType": "line",
                                "metadata": [{
                                    "aliasName": "Alpha",
                                    "expression": "avg:system.cpu.user{app:general} by {env}",
                                }],
                                "q": "avg:system.cpu.user{app:general} by {env}",
                                "style": {
                                    "lineType": "dashed",
                                    "lineWidth": "thin",
                                    "palette": "warm",
                                },
                            },
                            {
                                "displayType": "area",
                                "logQuery": {
                                    "computeQuery": {
                                        "aggregation": "avg",
                                        "facet": "@duration",
                                        "interval": 5000,
                                    },
                                    "groupBy": [{
                                        "facet": "host",
                                        "limit": 10,
                                        "sortQuery": {
                                            "aggregation": "avg",
                                            "facet": "@duration",
                                            "order": "desc",
                                        },
                                    }],
                                    "index": "mcnulty",
                                    "searchQuery": "status:info",
                                },
                            },
                            {
                                "apmQuery": {
                                    "computeQuery": {
                                        "aggregation": "avg",
                                        "facet": "@duration",
                                        "interval": 5000,
                                    },
                                    "groupBy": [{
                                        "facet": "resource_name",
                                        "limit": 50,
                                        "sortQuery": {
                                            "aggregation": "avg",
                                            "facet": "@string_query.interval",
                                            "order": "desc",
                                        },
                                    }],
                                    "index": "apm-search",
                                    "searchQuery": "type:web",
                                },
                                "displayType": "bars",
                            },
                            {
                                "displayType": "area",
                                "processQuery": {
                                    "filterBy": ["active"],
                                    "limit": 50,
                                    "metric": "process.stat.cpu.total_pct",
                                    "searchBy": "error",
                                },
                            },
                        ],
                        show_legend=True,
                        title="Widget Title",
                        yaxis=datadog.DashboardWidgetTimeseriesDefinitionYaxisArgs(
                            include_zero=False,
                            max="100",
                            scale="log",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    toplist_definition=datadog.DashboardWidgetToplistDefinitionArgs(
                        request=[{
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "q": "avg:system.cpu.user{app:general} by {env}",
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    group_definition=datadog.DashboardWidgetGroupDefinitionArgs(
                        layout_type="ordered",
                        title="Group Widget",
                        widget=[
                            {
                                "noteDefinition": {
                                    "backgroundColor": "pink",
                                    "content": "cluster note widget",
                                    "fontSize": "14",
                                    "showTick": True,
                                    "textAlign": "center",
                                    "tickEdge": "left",
                                    "tickPos": "50%",
                                },
                            },
                            {
                                "alertGraphDefinition": {
                                    "alertId": "123",
                                    "liveSpan": "1h",
                                    "title": "Alert Graph",
                                    "vizType": "toplist",
                                },
                            },
                        ],
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    service_level_objective_definition=datadog.DashboardWidgetServiceLevelObjectiveDefinitionArgs(
                        show_error_budget=True,
                        slo_id="56789",
                        time_windows=[
                            "7d",
                            "previous_week",
                        ],
                        title="Widget Title",
                        view_mode="overall",
                        view_type="detail",
                    ),
                ),
            ])
        # Example Free Layout
        free_dashboard = datadog.Dashboard("freeDashboard",
            description="Created using the Datadog provider in Terraform",
            is_read_only=False,
            layout_type="free",
            template_variables=[
                datadog.DashboardTemplateVariableArgs(
                    default="aws",
                    name="var_1",
                    prefix="host",
                ),
                datadog.DashboardTemplateVariableArgs(
                    default="autoscaling",
                    name="var_2",
                    prefix="service_name",
                ),
            ],
            template_variable_presets=[datadog.DashboardTemplateVariablePresetArgs(
                name="preset_1",
                template_variables=[
                    {
                        "name": "var_1",
                        "value": "host.dc",
                    },
                    {
                        "name": "var_2",
                        "value": "my_service",
                    },
                ],
            )],
            title="Free Layout Dashboard",
            widgets=[
                datadog.DashboardWidgetArgs(
                    event_stream_definition=datadog.DashboardWidgetEventStreamDefinitionArgs(
                        event_size="l",
                        live_span="1h",
                        query="*",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=43,
                        width=32,
                        x=0,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    event_timeline_definition=datadog.DashboardWidgetEventTimelineDefinitionArgs(
                        live_span="1h",
                        query="*",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=9,
                        width=66,
                        x=33,
                        y=60,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    free_text_definition=datadog.DashboardWidgetFreeTextDefinitionArgs(
                        color="#d00",
                        font_size="36",
                        text="free text content",
                        text_align="left",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=20,
                        width=34,
                        x=33,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    iframe_definition=datadog.DashboardWidgetIframeDefinitionArgs(
                        url="http://google.com",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=46,
                        width=39,
                        x=101,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    image_definition=datadog.DashboardWidgetImageDefinitionArgs(
                        margin="small",
                        sizing="fit",
                        url="https://images.pexels.com/photos/67636/rose-blue-flower-rose-blooms-67636.jpeg?auto=compress&cs=tinysrgb&h=350",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=20,
                        width=30,
                        x=69,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    log_stream_definition=datadog.DashboardWidgetLogStreamDefinitionArgs(
                        columns=[
                            "core_host",
                            "core_service",
                            "tag_source",
                        ],
                        indexes=["main"],
                        message_display="expanded-md",
                        query="error",
                        show_date_column=True,
                        show_message_column=True,
                        sort=datadog.DashboardWidgetLogStreamDefinitionSortArgs(
                            column="time",
                            order="desc",
                        ),
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=36,
                        width=32,
                        x=0,
                        y=45,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    manage_status_definition=datadog.DashboardWidgetManageStatusDefinitionArgs(
                        color_preference="text",
                        display_format="countsAndList",
                        hide_zero_counts=True,
                        query="type:metric",
                        show_last_triggered=False,
                        sort="status,asc",
                        summary_type="monitors",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=40,
                        width=30,
                        x=101,
                        y=48,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    trace_service_definition=datadog.DashboardWidgetTraceServiceDefinitionArgs(
                        display_format="three_column",
                        env="datad0g.com",
                        live_span="1h",
                        service="alerting-cassandra",
                        show_breakdown=True,
                        show_distribution=True,
                        show_errors=True,
                        show_hits=True,
                        show_latency=False,
                        show_resource_list=False,
                        size_format="large",
                        span_name="cassandra.query",
                        title="alerting-cassandra #env:datad0g.com",
                        title_align="center",
                        title_size="13",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=38,
                        width=66,
                        x=33,
                        y=21,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "formula": [
                                {
                                    "alias": "my ff query",
                                    "formulaExpression": "my_query_1 + my_query_2",
                                },
                                {
                                    "alias": "my second ff query",
                                    "formulaExpression": "my_query_1 * my_query_2",
                                    "limit": {
                                        "count": 5,
                                        "order": "desc",
                                    },
                                },
                            ],
                            "query": [
                                {
                                    "metricQuery": {
                                        "aggregator": "sum",
                                        "dataSource": "metrics",
                                        "name": "my_query_1",
                                        "query": "avg:system.cpu.user{app:general} by {env}",
                                    },
                                },
                                {
                                    "metricQuery": {
                                        "aggregator": "sum",
                                        "name": "my_query_2",
                                        "query": "avg:system.cpu.user{app:general} by {env}",
                                    },
                                },
                            ],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=25,
                        x=58,
                        y=83,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "query": [{
                                "eventQuery": {
                                    "compute": [{
                                        "aggregation": "count",
                                    }],
                                    "dataSource": "logs",
                                    "groupBy": [{
                                        "facet": "host",
                                        "limit": 10,
                                        "sort": {
                                            "aggregation": "avg",
                                            "metric": "@lambda.max_memory_used",
                                        },
                                    }],
                                    "indexes": ["days-3"],
                                    "name": "my-query",
                                },
                            }],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=28,
                        x=29,
                        y=83,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "query": [{
                                "processQuery": {
                                    "aggregator": "sum",
                                    "dataSource": "process",
                                    "isNormalizedCpu": True,
                                    "limit": 10,
                                    "metric": "process.stat.cpu.total_pct",
                                    "name": "my_process_query",
                                    "sort": "asc",
                                    "tagFilters": ["some_filter"],
                                    "textFilter": "abc",
                                },
                            }],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=28,
                        x=0,
                        y=83,
                    ),
                ),
            ])
        ```

        ## Import

        ```sh
         $ pulumi import datadog:index/dashboard:Dashboard my_service_dashboard sv7-gyh-kas
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists: The list of dashboard lists this dashboard belongs to.
        :param pulumi.Input[str] description: The description of the dashboard.
        :param pulumi.Input[bool] is_read_only: Whether this dashboard is read-only.
        :param pulumi.Input[str] layout_type: The layout type of the dashboard. Valid values are `ordered`, `free`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notify_lists: The list of handles of users to notify when changes are made to this dashboard.
        :param pulumi.Input[str] reflow_type: The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] restricted_roles: Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariablePresetArgs']]]] template_variable_presets: The list of selectable template variable presets for this dashboard.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariableArgs']]]] template_variables: The list of template variables for this dashboard.
        :param pulumi.Input[str] title: The title of the dashboard.
        :param pulumi.Input[str] url: The URL of the dashboard.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardWidgetArgs']]]] widgets: The list of widgets to display on the dashboard.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: DashboardArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Provides a Datadog dashboard resource. This can be used to create and manage Datadog dashboards.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_datadog as datadog

        # Example Ordered Layout
        ordered_dashboard = datadog.Dashboard("orderedDashboard",
            description="Created using the Datadog provider in Terraform",
            is_read_only=True,
            layout_type="ordered",
            template_variables=[
                datadog.DashboardTemplateVariableArgs(
                    default="aws",
                    name="var_1",
                    prefix="host",
                ),
                datadog.DashboardTemplateVariableArgs(
                    default="autoscaling",
                    name="var_2",
                    prefix="service_name",
                ),
            ],
            template_variable_presets=[datadog.DashboardTemplateVariablePresetArgs(
                name="preset_1",
                template_variables=[
                    {
                        "name": "var_1",
                        "value": "host.dc",
                    },
                    {
                        "name": "var_2",
                        "value": "my_service",
                    },
                ],
            )],
            title="Ordered Layout Dashboard",
            widgets=[
                datadog.DashboardWidgetArgs(
                    alert_graph_definition=datadog.DashboardWidgetAlertGraphDefinitionArgs(
                        alert_id="895605",
                        live_span="1h",
                        title="Widget Title",
                        viz_type="timeseries",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    alert_value_definition=datadog.DashboardWidgetAlertValueDefinitionArgs(
                        alert_id="895605",
                        precision=3,
                        text_align="center",
                        title="Widget Title",
                        unit="b",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    alert_value_definition=datadog.DashboardWidgetAlertValueDefinitionArgs(
                        alert_id="895605",
                        precision=3,
                        text_align="center",
                        title="Widget Title",
                        unit="b",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    change_definition=datadog.DashboardWidgetChangeDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "changeType": "absolute",
                            "compareTo": "week_before",
                            "increaseGood": True,
                            "orderBy": "name",
                            "orderDir": "desc",
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "showPresent": True,
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    distribution_definition=datadog.DashboardWidgetDistributionDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "style": {
                                "palette": "warm",
                            },
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    check_status_definition=datadog.DashboardWidgetCheckStatusDefinitionArgs(
                        check="aws.ecs.agent_connected",
                        group_by=[
                            "account",
                            "cluster",
                        ],
                        grouping="cluster",
                        live_span="1h",
                        tags=[
                            "account:demo",
                            "cluster:awseb-ruthebdog-env-8-dn3m6u3gvk",
                        ],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    heatmap_definition=datadog.DashboardWidgetHeatmapDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "q": "avg:system.load.1{env:staging} by {account}",
                            "style": {
                                "palette": "warm",
                            },
                        }],
                        title="Widget Title",
                        yaxis=datadog.DashboardWidgetHeatmapDefinitionYaxisArgs(
                            include_zero=True,
                            max="2",
                            min="1",
                            scale="sqrt",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    hostmap_definition=datadog.DashboardWidgetHostmapDefinitionArgs(
                        group=[
                            "host",
                            "region",
                        ],
                        no_group_hosts=True,
                        no_metric_hosts=True,
                        node_type="container",
                        request=datadog.DashboardWidgetHostmapDefinitionRequestArgs(
                            fill=[{
                                "q": "avg:system.load.1{*} by {host}",
                            }],
                            size=[{
                                "q": "avg:memcache.uptime{*} by {host}",
                            }],
                        ),
                        scope=[
                            "region:us-east-1",
                            "aws_account:727006795293",
                        ],
                        style=datadog.DashboardWidgetHostmapDefinitionStyleArgs(
                            fill_max="20",
                            fill_min="10",
                            palette="yellow_to_green",
                            palette_flip=True,
                        ),
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    note_definition=datadog.DashboardWidgetNoteDefinitionArgs(
                        background_color="pink",
                        content="note text",
                        font_size="14",
                        show_tick=True,
                        text_align="center",
                        tick_edge="left",
                        tick_pos="50%",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    query_value_definition=datadog.DashboardWidgetQueryValueDefinitionArgs(
                        autoscale=True,
                        custom_unit="xx",
                        live_span="1h",
                        precision=4,
                        request=[{
                            "aggregator": "sum",
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "q": "avg:system.load.1{env:staging} by {account}",
                        }],
                        text_align="right",
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    query_table_definition=datadog.DashboardWidgetQueryTableDefinitionArgs(
                        live_span="1h",
                        request=[{
                            "aggregator": "sum",
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "limit": "10",
                            "q": "avg:system.load.1{env:staging} by {account}",
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    scatterplot_definition=datadog.DashboardWidgetScatterplotDefinitionArgs(
                        color_by_groups=[
                            "account",
                            "apm-role-group",
                        ],
                        live_span="1h",
                        request=datadog.DashboardWidgetScatterplotDefinitionRequestArgs(
                            x=[{
                                "aggregator": "max",
                                "q": "avg:system.cpu.user{*} by {service, account}",
                            }],
                            y=[{
                                "aggregator": "min",
                                "q": "avg:system.mem.used{*} by {service, account}",
                            }],
                        ),
                        title="Widget Title",
                        xaxis=datadog.DashboardWidgetScatterplotDefinitionXaxisArgs(
                            include_zero=True,
                            label="x",
                            max="2000",
                            min="1",
                            scale="pow",
                        ),
                        yaxis=datadog.DashboardWidgetScatterplotDefinitionYaxisArgs(
                            include_zero=False,
                            label="y",
                            max="2222",
                            min="5",
                            scale="log",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    servicemap_definition=datadog.DashboardWidgetServicemapDefinitionArgs(
                        filters=[
                            "env:prod",
                            "datacenter:us1.prod.dog",
                        ],
                        service="master-db",
                        title="env: prod, datacenter:us1.prod.dog, service: master-db",
                        title_align="left",
                        title_size="16",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        event=[
                            {
                                "q": "sources:test tags:1",
                            },
                            {
                                "q": "sources:test tags:2",
                            },
                        ],
                        legend_size="2",
                        live_span="1h",
                        marker=[
                            {
                                "displayType": "error dashed",
                                "label": " z=6 ",
                                "value": "y = 4",
                            },
                            {
                                "displayType": "ok solid",
                                "label": " x=8 ",
                                "value": "10 < y < 999",
                            },
                        ],
                        request=[
                            {
                                "displayType": "line",
                                "metadata": [{
                                    "aliasName": "Alpha",
                                    "expression": "avg:system.cpu.user{app:general} by {env}",
                                }],
                                "q": "avg:system.cpu.user{app:general} by {env}",
                                "style": {
                                    "lineType": "dashed",
                                    "lineWidth": "thin",
                                    "palette": "warm",
                                },
                            },
                            {
                                "displayType": "area",
                                "logQuery": {
                                    "computeQuery": {
                                        "aggregation": "avg",
                                        "facet": "@duration",
                                        "interval": 5000,
                                    },
                                    "groupBy": [{
                                        "facet": "host",
                                        "limit": 10,
                                        "sortQuery": {
                                            "aggregation": "avg",
                                            "facet": "@duration",
                                            "order": "desc",
                                        },
                                    }],
                                    "index": "mcnulty",
                                    "searchQuery": "status:info",
                                },
                            },
                            {
                                "apmQuery": {
                                    "computeQuery": {
                                        "aggregation": "avg",
                                        "facet": "@duration",
                                        "interval": 5000,
                                    },
                                    "groupBy": [{
                                        "facet": "resource_name",
                                        "limit": 50,
                                        "sortQuery": {
                                            "aggregation": "avg",
                                            "facet": "@string_query.interval",
                                            "order": "desc",
                                        },
                                    }],
                                    "index": "apm-search",
                                    "searchQuery": "type:web",
                                },
                                "displayType": "bars",
                            },
                            {
                                "displayType": "area",
                                "processQuery": {
                                    "filterBy": ["active"],
                                    "limit": 50,
                                    "metric": "process.stat.cpu.total_pct",
                                    "searchBy": "error",
                                },
                            },
                        ],
                        show_legend=True,
                        title="Widget Title",
                        yaxis=datadog.DashboardWidgetTimeseriesDefinitionYaxisArgs(
                            include_zero=False,
                            max="100",
                            scale="log",
                        ),
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    toplist_definition=datadog.DashboardWidgetToplistDefinitionArgs(
                        request=[{
                            "conditionalFormats": [
                                {
                                    "comparator": "<",
                                    "palette": "white_on_green",
                                    "value": "2",
                                },
                                {
                                    "comparator": ">",
                                    "palette": "white_on_red",
                                    "value": "2.2",
                                },
                            ],
                            "q": "avg:system.cpu.user{app:general} by {env}",
                        }],
                        title="Widget Title",
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    group_definition=datadog.DashboardWidgetGroupDefinitionArgs(
                        layout_type="ordered",
                        title="Group Widget",
                        widget=[
                            {
                                "noteDefinition": {
                                    "backgroundColor": "pink",
                                    "content": "cluster note widget",
                                    "fontSize": "14",
                                    "showTick": True,
                                    "textAlign": "center",
                                    "tickEdge": "left",
                                    "tickPos": "50%",
                                },
                            },
                            {
                                "alertGraphDefinition": {
                                    "alertId": "123",
                                    "liveSpan": "1h",
                                    "title": "Alert Graph",
                                    "vizType": "toplist",
                                },
                            },
                        ],
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    service_level_objective_definition=datadog.DashboardWidgetServiceLevelObjectiveDefinitionArgs(
                        show_error_budget=True,
                        slo_id="56789",
                        time_windows=[
                            "7d",
                            "previous_week",
                        ],
                        title="Widget Title",
                        view_mode="overall",
                        view_type="detail",
                    ),
                ),
            ])
        # Example Free Layout
        free_dashboard = datadog.Dashboard("freeDashboard",
            description="Created using the Datadog provider in Terraform",
            is_read_only=False,
            layout_type="free",
            template_variables=[
                datadog.DashboardTemplateVariableArgs(
                    default="aws",
                    name="var_1",
                    prefix="host",
                ),
                datadog.DashboardTemplateVariableArgs(
                    default="autoscaling",
                    name="var_2",
                    prefix="service_name",
                ),
            ],
            template_variable_presets=[datadog.DashboardTemplateVariablePresetArgs(
                name="preset_1",
                template_variables=[
                    {
                        "name": "var_1",
                        "value": "host.dc",
                    },
                    {
                        "name": "var_2",
                        "value": "my_service",
                    },
                ],
            )],
            title="Free Layout Dashboard",
            widgets=[
                datadog.DashboardWidgetArgs(
                    event_stream_definition=datadog.DashboardWidgetEventStreamDefinitionArgs(
                        event_size="l",
                        live_span="1h",
                        query="*",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=43,
                        width=32,
                        x=0,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    event_timeline_definition=datadog.DashboardWidgetEventTimelineDefinitionArgs(
                        live_span="1h",
                        query="*",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=9,
                        width=66,
                        x=33,
                        y=60,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    free_text_definition=datadog.DashboardWidgetFreeTextDefinitionArgs(
                        color="#d00",
                        font_size="36",
                        text="free text content",
                        text_align="left",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=20,
                        width=34,
                        x=33,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    iframe_definition=datadog.DashboardWidgetIframeDefinitionArgs(
                        url="http://google.com",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=46,
                        width=39,
                        x=101,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    image_definition=datadog.DashboardWidgetImageDefinitionArgs(
                        margin="small",
                        sizing="fit",
                        url="https://images.pexels.com/photos/67636/rose-blue-flower-rose-blooms-67636.jpeg?auto=compress&cs=tinysrgb&h=350",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=20,
                        width=30,
                        x=69,
                        y=0,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    log_stream_definition=datadog.DashboardWidgetLogStreamDefinitionArgs(
                        columns=[
                            "core_host",
                            "core_service",
                            "tag_source",
                        ],
                        indexes=["main"],
                        message_display="expanded-md",
                        query="error",
                        show_date_column=True,
                        show_message_column=True,
                        sort=datadog.DashboardWidgetLogStreamDefinitionSortArgs(
                            column="time",
                            order="desc",
                        ),
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=36,
                        width=32,
                        x=0,
                        y=45,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    manage_status_definition=datadog.DashboardWidgetManageStatusDefinitionArgs(
                        color_preference="text",
                        display_format="countsAndList",
                        hide_zero_counts=True,
                        query="type:metric",
                        show_last_triggered=False,
                        sort="status,asc",
                        summary_type="monitors",
                        title="Widget Title",
                        title_align="left",
                        title_size="16",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=40,
                        width=30,
                        x=101,
                        y=48,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    trace_service_definition=datadog.DashboardWidgetTraceServiceDefinitionArgs(
                        display_format="three_column",
                        env="datad0g.com",
                        live_span="1h",
                        service="alerting-cassandra",
                        show_breakdown=True,
                        show_distribution=True,
                        show_errors=True,
                        show_hits=True,
                        show_latency=False,
                        show_resource_list=False,
                        size_format="large",
                        span_name="cassandra.query",
                        title="alerting-cassandra #env:datad0g.com",
                        title_align="center",
                        title_size="13",
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=38,
                        width=66,
                        x=33,
                        y=21,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "formula": [
                                {
                                    "alias": "my ff query",
                                    "formulaExpression": "my_query_1 + my_query_2",
                                },
                                {
                                    "alias": "my second ff query",
                                    "formulaExpression": "my_query_1 * my_query_2",
                                    "limit": {
                                        "count": 5,
                                        "order": "desc",
                                    },
                                },
                            ],
                            "query": [
                                {
                                    "metricQuery": {
                                        "aggregator": "sum",
                                        "dataSource": "metrics",
                                        "name": "my_query_1",
                                        "query": "avg:system.cpu.user{app:general} by {env}",
                                    },
                                },
                                {
                                    "metricQuery": {
                                        "aggregator": "sum",
                                        "name": "my_query_2",
                                        "query": "avg:system.cpu.user{app:general} by {env}",
                                    },
                                },
                            ],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=25,
                        x=58,
                        y=83,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "query": [{
                                "eventQuery": {
                                    "compute": [{
                                        "aggregation": "count",
                                    }],
                                    "dataSource": "logs",
                                    "groupBy": [{
                                        "facet": "host",
                                        "limit": 10,
                                        "sort": {
                                            "aggregation": "avg",
                                            "metric": "@lambda.max_memory_used",
                                        },
                                    }],
                                    "indexes": ["days-3"],
                                    "name": "my-query",
                                },
                            }],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=28,
                        x=29,
                        y=83,
                    ),
                ),
                datadog.DashboardWidgetArgs(
                    timeseries_definition=datadog.DashboardWidgetTimeseriesDefinitionArgs(
                        request=[{
                            "query": [{
                                "processQuery": {
                                    "aggregator": "sum",
                                    "dataSource": "process",
                                    "isNormalizedCpu": True,
                                    "limit": 10,
                                    "metric": "process.stat.cpu.total_pct",
                                    "name": "my_process_query",
                                    "sort": "asc",
                                    "tagFilters": ["some_filter"],
                                    "textFilter": "abc",
                                },
                            }],
                        }],
                    ),
                    widget_layout=datadog.DashboardWidgetWidgetLayoutArgs(
                        height=16,
                        width=28,
                        x=0,
                        y=83,
                    ),
                ),
            ])
        ```

        ## Import

        ```sh
         $ pulumi import datadog:index/dashboard:Dashboard my_service_dashboard sv7-gyh-kas
        ```

        :param str resource_name: The name of the resource.
        :param DashboardArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(DashboardArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dashboard_lists: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 description: Optional[pulumi.Input[str]] = None,
                 is_read_only: Optional[pulumi.Input[bool]] = None,
                 layout_type: Optional[pulumi.Input[str]] = None,
                 notify_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 reflow_type: Optional[pulumi.Input[str]] = None,
                 restricted_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 template_variable_presets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariablePresetArgs']]]]] = None,
                 template_variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariableArgs']]]]] = None,
                 title: Optional[pulumi.Input[str]] = None,
                 url: Optional[pulumi.Input[str]] = None,
                 widgets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardWidgetArgs']]]]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = DashboardArgs.__new__(DashboardArgs)

            __props__.__dict__["dashboard_lists"] = dashboard_lists
            __props__.__dict__["description"] = description
            __props__.__dict__["is_read_only"] = is_read_only
            if layout_type is None and not opts.urn:
                raise TypeError("Missing required property 'layout_type'")
            __props__.__dict__["layout_type"] = layout_type
            __props__.__dict__["notify_lists"] = notify_lists
            __props__.__dict__["reflow_type"] = reflow_type
            __props__.__dict__["restricted_roles"] = restricted_roles
            __props__.__dict__["template_variable_presets"] = template_variable_presets
            __props__.__dict__["template_variables"] = template_variables
            if title is None and not opts.urn:
                raise TypeError("Missing required property 'title'")
            __props__.__dict__["title"] = title
            __props__.__dict__["url"] = url
            if widgets is None and not opts.urn:
                raise TypeError("Missing required property 'widgets'")
            __props__.__dict__["widgets"] = widgets
            __props__.__dict__["dashboard_lists_removeds"] = None
        super(Dashboard, __self__).__init__(
            'datadog:index/dashboard:Dashboard',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            dashboard_lists: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            dashboard_lists_removeds: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
            description: Optional[pulumi.Input[str]] = None,
            is_read_only: Optional[pulumi.Input[bool]] = None,
            layout_type: Optional[pulumi.Input[str]] = None,
            notify_lists: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            reflow_type: Optional[pulumi.Input[str]] = None,
            restricted_roles: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
            template_variable_presets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariablePresetArgs']]]]] = None,
            template_variables: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariableArgs']]]]] = None,
            title: Optional[pulumi.Input[str]] = None,
            url: Optional[pulumi.Input[str]] = None,
            widgets: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardWidgetArgs']]]]] = None) -> 'Dashboard':
        """
        Get an existing Dashboard resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists: The list of dashboard lists this dashboard belongs to.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] dashboard_lists_removeds: The list of dashboard lists this dashboard should be removed from. Internal only.
        :param pulumi.Input[str] description: The description of the dashboard.
        :param pulumi.Input[bool] is_read_only: Whether this dashboard is read-only.
        :param pulumi.Input[str] layout_type: The layout type of the dashboard. Valid values are `ordered`, `free`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] notify_lists: The list of handles of users to notify when changes are made to this dashboard.
        :param pulumi.Input[str] reflow_type: The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        :param pulumi.Input[Sequence[pulumi.Input[str]]] restricted_roles: Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariablePresetArgs']]]] template_variable_presets: The list of selectable template variable presets for this dashboard.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardTemplateVariableArgs']]]] template_variables: The list of template variables for this dashboard.
        :param pulumi.Input[str] title: The title of the dashboard.
        :param pulumi.Input[str] url: The URL of the dashboard.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['DashboardWidgetArgs']]]] widgets: The list of widgets to display on the dashboard.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _DashboardState.__new__(_DashboardState)

        __props__.__dict__["dashboard_lists"] = dashboard_lists
        __props__.__dict__["dashboard_lists_removeds"] = dashboard_lists_removeds
        __props__.__dict__["description"] = description
        __props__.__dict__["is_read_only"] = is_read_only
        __props__.__dict__["layout_type"] = layout_type
        __props__.__dict__["notify_lists"] = notify_lists
        __props__.__dict__["reflow_type"] = reflow_type
        __props__.__dict__["restricted_roles"] = restricted_roles
        __props__.__dict__["template_variable_presets"] = template_variable_presets
        __props__.__dict__["template_variables"] = template_variables
        __props__.__dict__["title"] = title
        __props__.__dict__["url"] = url
        __props__.__dict__["widgets"] = widgets
        return Dashboard(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dashboardLists")
    def dashboard_lists(self) -> pulumi.Output[Optional[Sequence[int]]]:
        """
        The list of dashboard lists this dashboard belongs to.
        """
        return pulumi.get(self, "dashboard_lists")

    @property
    @pulumi.getter(name="dashboardListsRemoveds")
    def dashboard_lists_removeds(self) -> pulumi.Output[Sequence[int]]:
        """
        The list of dashboard lists this dashboard should be removed from. Internal only.
        """
        return pulumi.get(self, "dashboard_lists_removeds")

    @property
    @pulumi.getter
    def description(self) -> pulumi.Output[Optional[str]]:
        """
        The description of the dashboard.
        """
        return pulumi.get(self, "description")

    @property
    @pulumi.getter(name="isReadOnly")
    def is_read_only(self) -> pulumi.Output[Optional[bool]]:
        """
        Whether this dashboard is read-only.
        """
        return pulumi.get(self, "is_read_only")

    @property
    @pulumi.getter(name="layoutType")
    def layout_type(self) -> pulumi.Output[str]:
        """
        The layout type of the dashboard. Valid values are `ordered`, `free`.
        """
        return pulumi.get(self, "layout_type")

    @property
    @pulumi.getter(name="notifyLists")
    def notify_lists(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        The list of handles of users to notify when changes are made to this dashboard.
        """
        return pulumi.get(self, "notify_lists")

    @property
    @pulumi.getter(name="reflowType")
    def reflow_type(self) -> pulumi.Output[Optional[str]]:
        """
        The reflow type of a new dashboard layout. Set this only when layout type is `ordered`. If set to `fixed`, the dashboard expects all widgets to have a layout, and if it's set to `auto`, widgets should not have layouts. Valid values are `auto`, `fixed`.
        """
        return pulumi.get(self, "reflow_type")

    @property
    @pulumi.getter(name="restrictedRoles")
    def restricted_roles(self) -> pulumi.Output[Optional[Sequence[str]]]:
        """
        Role UUIDs corresponding to users authorized to edit the dashboard. **This feature is currently in beta.**
        """
        return pulumi.get(self, "restricted_roles")

    @property
    @pulumi.getter(name="templateVariablePresets")
    def template_variable_presets(self) -> pulumi.Output[Optional[Sequence['outputs.DashboardTemplateVariablePreset']]]:
        """
        The list of selectable template variable presets for this dashboard.
        """
        return pulumi.get(self, "template_variable_presets")

    @property
    @pulumi.getter(name="templateVariables")
    def template_variables(self) -> pulumi.Output[Optional[Sequence['outputs.DashboardTemplateVariable']]]:
        """
        The list of template variables for this dashboard.
        """
        return pulumi.get(self, "template_variables")

    @property
    @pulumi.getter
    def title(self) -> pulumi.Output[str]:
        """
        The title of the dashboard.
        """
        return pulumi.get(self, "title")

    @property
    @pulumi.getter
    def url(self) -> pulumi.Output[str]:
        """
        The URL of the dashboard.
        """
        return pulumi.get(self, "url")

    @property
    @pulumi.getter
    def widgets(self) -> pulumi.Output[Sequence['outputs.DashboardWidget']]:
        """
        The list of widgets to display on the dashboard.
        """
        return pulumi.get(self, "widgets")

